//+------------------------------------------------------------------+
//|                                                        tick data |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#include <WinUser32.mqh>
#import "user32.dll"
   int RegisterWindowMessageA(string a0);
#import
#define  CHART_CMD_UPDATE_DATA 33324

//
//
//
//
//

extern int  TicksPerBar = 1;
extern bool ResetData   = false;
extern bool ShowComment = false;

//
//
//
//
//

int      fileHandle = -1;
int      filePeriod =  1;
string   fileSymbol;

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   TicksPerBar = MathMax(TicksPerBar,1);
   fileSymbol  = "_t"+Symbol();
      if (OpenHistoryFile()<0) return(-1);
   return (0);
}
void deinit()
{
   if (fileHandle >= 0) { FileClose(fileHandle);  fileHandle = -1; }
   if (ShowComment) Comment("");
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int OpenHistoryFile()
{
   string name = fileSymbol+filePeriod;
      if (ResetData)
         {
            fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE);
            if (fileHandle>=0) FileClose(fileHandle);
         }            
      fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE|FILE_READ);
       
      //
      //
      //
      //
      //
       
      if (fileHandle >=0)
      {
         int size = FileSeek(fileHandle,0,SEEK_END);
         if (size<148)
                     WriteHistoryHeader();
         return(0);
      }
      else return(-1);
}

//
//
//
//
//

int WriteHistoryHeader()
{
   string c_copyright  = "(C)opyright 2003, MetaQuotes Software Corp.";
   int    digits       = Digits;
   int    unused[13]   = {0};
   int    version      = 400;   

   if (fileHandle >= 0)
   {
      FileWriteInteger(fileHandle, version, LONG_VALUE);
      FileWriteString(fileHandle, c_copyright, 64);
      FileWriteString(fileHandle, fileSymbol , 12);
      FileWriteInteger(fileHandle, filePeriod, LONG_VALUE);
      FileWriteInteger(fileHandle, digits    , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);
      FileWriteArray(fileHandle, unused, 0, ArraySize(unused));
                 FileFlush(fileHandle);
   }
   return (0);
}

//
//
//
//
//

void WriteHistoryData(datetime time, double bidPrice, double askPrice)
{
   if (fileHandle >= 0)
   {
      bool found = FileSeek(fileHandle,0,SEEK_END);
   
      //
      //
      //
      //
      //
      
      if (TicksPerBar==1)
         {
            datetime tT = time;     // time of the bar
            double   tO = askPrice; // tick open
            double   tL = bidPrice; // tick low
            double   tH = askPrice; // tick high
            double   tC = bidPrice; // tick close
            double   tV = 1;
         }
      else
         {               
            if (found)
            {
               int size = FileTell(fileHandle);
               if (size>=192)
               {
                   found = FileSeek(fileHandle,size-44,SEEK_SET);
                           tT = FileReadInteger(fileHandle,LONG_VALUE);
                           tO = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tL = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tH = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tC = FileReadDouble(fileHandle,DOUBLE_VALUE);
                           tV = FileReadDouble(fileHandle,DOUBLE_VALUE);
                   if (tV<TicksPerBar)                           
                        found = FileSeek(fileHandle,size-44,SEEK_SET);
                   else found = FileSeek(fileHandle,      0,SEEK_END);
               }
               else tV = TicksPerBar;
               
               //
               //
               //
               //
               //
                  
               if  (tV >= TicksPerBar)
                  {
                        tT = time;
                        tO = bidPrice;
                        tL = bidPrice;
                        tH = bidPrice;
                        tC = bidPrice;
                        tV = 1;
                  }
               else                     
                  {
                     tV    = tV+1;
                     tH    = MathMax(tH,bidPrice);
                     tL    = MathMin(tL,bidPrice);
                     tC    = bidPrice;
                  }
            }
         }

      //
      //
      //
      //
      //
         
         if (found)
         {
            FileWriteInteger(fileHandle, tT, LONG_VALUE);   //    time
            FileWriteDouble(fileHandle, tO, DOUBLE_VALUE);  //    open
            FileWriteDouble(fileHandle, tL, DOUBLE_VALUE);  //    low
            FileWriteDouble(fileHandle, tH, DOUBLE_VALUE);  //    high
            FileWriteDouble(fileHandle, tC, DOUBLE_VALUE);  //    close
            FileWriteDouble(fileHandle, tV, DOUBLE_VALUE);  //    volume
 
            //
            //
            //    update time of last synchronization
            //
            //
        
            FileSeek(fileHandle,88,SEEK_SET);
            FileWriteInteger(fileHandle,time,LONG_VALUE);
            FileWriteInteger(fileHandle,time,LONG_VALUE);
         
         //
         //
         //
         //
         //
         
         FileFlush(fileHandle);
         if (ShowComment) Comment("tick saved at : "+TimeToStr(TimeLocal(),TIME_SECONDS));
      }
   }
}

//
//
//
//
//

int UpdateChartWindow()
{
   static int hwnd = 0;
          int messageHandle = RegisterWindowMessageA("MetaTrader4_Internal_Message");

   if(fileHandle < 0) return (-1);
   if(hwnd == 0) hwnd = WindowHandle(fileSymbol,filePeriod);
   if(hwnd != 0)
   {
      if (IsDllsAllowed())
      if    (PostMessageA(hwnd,WM_COMMAND,CHART_CMD_UPDATE_DATA,0) == 0) hwnd = 0;
      else  PostMessageA(hwnd, messageHandle, 2, 1);
      
   }
   return (0);
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (fileHandle<0) return(0);

         WriteHistoryData(TimeCurrent(),Bid,Ask);
         UpdateChartWindow();
}